Loading...
Searching...
No Matches
Sip_referred_by

## Data Structures

struct | sip_referred_by_s
| Structure for Referred-By header. More...

## Macros

#define | sip_referred_by(sip)
| Access a SIP Referred-By header structure sip_referred_by_t from sip_t.
#define | SIP_REFERRED_BY_INIT()
| Initializer for structure sip_referred_by_t.
#define | SIPTAG_REFERRED_BY(x)
| Tag list item for pointer to a Referred-By header structure sip_referred_by_t.
#define | SIPTAG_REFERRED_BY_REF(x)
| Tag list item for reference to a Referred-By header pointer.
#define | SIPTAG_REFERRED_BY_STR(s)
| Tag list item for string with Referred-By header value.
#define | SIPTAG_REFERRED_BY_STR_REF(x)
| Tag list item for reference to a Referred-By header string.

## Typedefs

typedef struct sip_referred_by_s | sip_referred_by_t
| @

## Functions

issize_t | sip_referred_by_d (su_home_t *, msg_header_t *, char *s, isize_t slen)
| Parse a SIP Referred-By header.
issize_t | sip_referred_by_e (char b[], isize_t bsiz, msg_header_t const *h, int flags)
| Print a SIP Referred-By header.
sip_referred_by_t * | sip_referred_by_init (sip_referred_by_t x[1])
| Initialize a structure sip_referred_by_t.
int | sip_is_referred_by (sip_header_t const *header)
| Test if header object is instance of sip_referred_by_t.
sip_referred_by_t * | sip_referred_by_dup (su_home_t *home, sip_referred_by_t const *hdr))
| Duplicate a list of Referred-By header header structures sip_referred_by_t.
sip_referred_by_t * | sip_referred_by_copy (su_home_t *home, sip_referred_by_t const *hdr))
| Copy a list of Referred-By header header structures sip_referred_by_t.
sip_referred_by_t * | sip_referred_by_make (su_home_t *home, char const *s))
| Make a Referred-By header structure sip_referred_by_t.
sip_referred_by_t * | sip_referred_by_format (su_home_t *home, char const *fmt,...)))
| Make a Referred-By header from formatting result.

## Variables

msg_hclass_t | sip_referred_by_class []
| Header class for Referred-By header.
tag_typedef_t | siptag_referred_by
| Tag for Referred-By header object.
tag_typedef_t | siptag_referred_by_str
| Tag for string with Referred-By header value.

## Detailed Description

## Macro Definition Documentation

## SIP_REFERRED_BY_INIT

#define SIP_REFERRED_BY_INIT | ( |  | ) |

Initializer for structure sip_referred_by_t.

A static sip_referred_by_t structure for Referred-By header must be initialized with the SIP_REFERRED_BY_INIT() macro. For instance,

sip_referred_by_t sip_referred_by = SIP_REFERRED_BY_INIT;
SIP_REFERRED_BY_INIT
#define SIP_REFERRED_BY_INIT()
Initializer for structure sip_referred_by_t.
Definition sip_protos.h:11572
sip_referred_by
#define sip_referred_by(sip)
Access a SIP Referred-By header structure sip_referred_by_t from sip_t.
Definition sip_protos.h:11555
sip_referred_by_t
struct sip_referred_by_s sip_referred_by_t
@
Definition sip.h:176

## SIPTAG_REFERRED_BY

#define SIPTAG_REFERRED_BY | ( |  | x | ) |

Tag list item for pointer to a Referred-By header structure sip_referred_by_t.

The SIPTAG_REFERRED_BY() macro is used to include a tag item with a pointer to a sip_referred_by_t structure in a tag list.

Parameters

  x | pointer to a sip_referred_by_t structure, or NULL.

The corresponding tag taking reference parameter is SIPTAG_REFERRED_BY_REF().

## SIPTAG_REFERRED_BY_STR

#define SIPTAG_REFERRED_BY_STR | ( |  | s | ) |

Tag list item for string with Referred-By header value.

The SIPTAG_REFERRED_BY_STR() macro is used to include a tag item with a string containing value of a sip_referred_by_t header in a tag list.

Parameters

  s | pointer to a string containing Referred-By header value, or NULL.

The string in SIPTAG_REFERRED_BY_STR() can be converted to a sip_referred_by_t header structure by giving the string s has second argument to function sip_referred_by_make().

The corresponding tag taking reference parameter is SIPTAG_REFERRED_BY_STR_REF().

## Typedef Documentation

## sip_referred_by_t

typedef struct sip_referred_by_s sip_referred_by_t

@

The Referred-By header conveys the identity of the original referrer to the referred-to party. Its syntax is defined in RFC 3892 section 3 as follows:

Referred-By = ("Referred-By" / "b") HCOLON referrer-uri
*( SEMI (referredby-id-param / generic-param) )
referrer-uri = ( name-addr / addr-spec )
referredby-id-param = "cid" EQUAL sip-clean-msg-id
sip-clean-msg-id = LDQUOT dot-atom "@" (dot-atom / host) RDQUOT
dot-atom = atom *( "." atom )
atom = 1*( alphanum / "-" / "!" / "%" / "*" /
"_" / "+" / "'" / "`" / "~" )

The parsed Referred-By header is stored in sip_referred_by_t structure.

The structure sip_referred_by_t contains representation of Referred-By header.

The sip_referred_by_t is defined as follows:

typedef struct sip_referred_by_s
{
sip_common_t b_common[1]; // Common fragment info
sip_error_t *b_next; // Link to next (dummy)
char const b_display,
url_t b_url[1]; // Referrer-URI
msg_param_t const *b_params; // List of parameters
char const *b_cid;
} sip_referred_by_t;
sip_error_t
msg_error_t sip_error_t
@
Definition sip.h:134
sip_common_t
msg_common_t sip_common_t
Common part of all the header structures.
Definition sip.h:121
sip_referred_by_s
Structure for Referred-By header.
Definition sip.h:604
sip_referred_by_s::b_next
sip_error_t * b_next
Link to next (dummy).
Definition sip.h:606
sip_referred_by_s::b_common
sip_common_t b_common[1]
Common fragment info.
Definition sip.h:605
sip_referred_by_s::b_cid
char const * b_cid
The cid parameter.
Definition sip.h:610
sip_referred_by_s::b_url
url_t b_url[1]
Referrer-URI.
Definition sip.h:608
sip_referred_by_s::b_params
msg_param_t const * b_params
List of parameters.
Definition sip.h:609
url_t

## Function Documentation

## sip_is_referred_by()

int sip_is_referred_by | ( | sip_header_t const * | header | ) |

inline

Test if header object is instance of sip_referred_by_t.

Check if the header class is an instance of Referred-By header object and return true (nonzero), otherwise return false (zero).

Parameters

  header | pointer to the header structure to be tested

Return values

  1 | (true) if the header is an instance of header referred_by
  0 | (false) otherwise

## sip_referred_by_copy()

sip_referred_by_t * sip_referred_by_copy | ( | su_home_t * | home,
|  | sip_referred_by_t const * | hdr )

inline

Copy a list of Referred-By header header structures sip_referred_by_t.

The function sip_referred_by_copy() copies a header structure hdr. If the header structure hdr contains a reference (`hdr->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the list of header structure hdr.

Parameters

  home | memory home used to allocate new structure
  hdr | pointer to the header structure to be copied

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old hdr header, including the encoding of the old header, if present.

Example
  referred_by = sip_referred_by_copy(home, sip->sip_referred_by);
  sip_referred_by_copy
  sip_referred_by_t * sip_referred_by_copy(su_home_t *home, sip_referred_by_t const *hdr))
  Copy a list of Referred-By header header structures sip_referred_by_t.
  Definition sip_protos.h:11702

Returns
  A pointer to newly copied header structure, or NULL upon an error.

## sip_referred_by_dup()

sip_referred_by_t * sip_referred_by_dup | ( | su_home_t * | home,
|  | sip_referred_by_t const * | hdr )

inline

Duplicate a list of Referred-By header header structures sip_referred_by_t.

Duplicate a header structure hdr. If the header structure hdr contains a reference (`hdr->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  hdr | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  referred_by = sip_referred_by_dup(home, sip->sip_referred_by);
  sip_referred_by_dup
  sip_referred_by_t * sip_referred_by_dup(su_home_t *home, sip_referred_by_t const *hdr))
  Duplicate a list of Referred-By header header structures sip_referred_by_t.
  Definition sip_protos.h:11659

Returns
  A pointer to the newly duplicated sip_referred_by_t header structure, or NULL upon an error.

## sip_referred_by_format()

sip_referred_by_t * sip_referred_by_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a Referred-By header from formatting result.

Make a new sip_referred_by_t object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and parses the formatting result to the structure sip_referred_by_t.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Returns
  A pointer to newly makes header structure, or NULL upon an error.

## sip_referred_by_init()

sip_referred_by_t * sip_referred_by_init | ( | sip_referred_by_t | x[1] | ) |

inline

Initialize a structure sip_referred_by_t.

An sip_referred_by_t structure for Referred-By header can be initialized with the sip_referred_by_init() function/macro. For instance,

sip_referred_by_t sip_referred_by;
sip_referred_by_init(&sip_referred_by);
sip_referred_by_init
sip_referred_by_t * sip_referred_by_init(sip_referred_by_t x[1])
Initialize a structure sip_referred_by_t.
Definition sip_protos.h:11590

## sip_referred_by_make()

sip_referred_by_t * sip_referred_by_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a Referred-By header structure sip_referred_by_t.

The function sip_referred_by_make() makes a new sip_referred_by_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Returns
  A pointer to newly maked sip_referred_by_t header structure, or NULL upon an error.

## Variable Documentation

## sip_referred_by_class

msg_hclass_t sip_referred_by_class[]

extern

Header class for Referred-By header.

The header class sip_referred_by_class defines how a SIP Referred-By header is parsed and printed. It also contains methods used by SIP parser and other functions to manipulate the sip_referred_by_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.